/*
THIS INFRAGISTICS ULTIMATE SOFTWARE LICENSE  AGREEMENT ("AGREEMENT") LOCATED HERE:
https://www.infragistics.com/legal/license/igultimate-la
https://www.infragistics.com/legal/license/igultimate-eula
GOVERNS THE LICENSING, INSTALLATION AND USE OF INFRAGISTICS SOFTWARE. BY DOWNLOADING AND/OR INSTALLING AND USING INFRAGISTICS SOFTWARE:  you are indicating that you have read and understand this Agreement, and agree to be legally bound by it on behalf of the yourself and your company.
*/
import { ShapeSeriesBase } from "./ShapeSeriesBase";
import { ShapeAxisInfoCache } from "./ShapeAxisInfoCache";
import { StyleSelector } from "./StyleSelector";
import { DependencyProperty } from "igniteui-angular-core";
import { Style } from "igniteui-angular-core";
import { MarkerType_$type } from "./MarkerType";
import { DataTemplate } from "igniteui-angular-core";
import { Brush } from "igniteui-angular-core";
import { CollisionAvoidanceType_$type } from "./CollisionAvoidanceType";
import { MarkerOutlineMode_$type } from "./MarkerOutlineMode";
import { MarkerFillMode_$type } from "./MarkerFillMode";
import { Rect } from "igniteui-angular-core";
import { ScalerParams } from "./ScalerParams";
import { Base, runOn, enumGetBox, Number_$type, typeCast, fromEnum, markType, markDep, PointUtil } from "igniteui-angular-core";
import { Dictionary$2 } from "igniteui-angular-core";
import { OwnedPoint } from "./OwnedPoint";
import { ShapeSeriesViewBase } from "./ShapeSeriesViewBase";
import { Marker } from "./Marker";
import { MarkerSeries } from "./MarkerSeries";
import { BrushUtil } from "igniteui-angular-core";
import { DataContext } from "igniteui-angular-core";
import { HashPool$2 } from "igniteui-angular-core";
import { List$1 } from "igniteui-angular-core";
import { SeriesPointOfInterest } from "./SeriesPointOfInterest";
import { RectUtil } from "igniteui-angular-core";
import { ChartSelection } from "./ChartSelection";
import { PropertyMetadata } from "igniteui-angular-core";
import { DeviceUtils } from "igniteui-angular-core";
import { isNaN_, isInfinity } from "igniteui-angular-core";
import { NumericMarkerManager } from "./NumericMarkerManager";
import { DataTemplateMeasureInfo } from "igniteui-angular-core";
import { Size } from "igniteui-angular-core";
import { Defaults } from "./Defaults";
import { DataTemplatePassInfo } from "igniteui-angular-core";
import { DataTemplateRenderInfo } from "igniteui-angular-core";
import { MarkerVisualData } from "./MarkerVisualData";
import { stringIsNullOrEmpty } from "igniteui-angular-core";
/**
 * @hidden
 */
export let ScatterPolygonSeries = /*@__PURE__*/ (() => {
    class ScatterPolygonSeries extends ShapeSeriesBase {
        constructor() {
            super();
            this.aav = null;
            this.aas = new ScalerParams(1, ScatterPolygonSeries.ab1, ScatterPolygonSeries.ab1, false);
            this.aat = new ScalerParams(1, ScatterPolygonSeries.ab1, ScatterPolygonSeries.ab1, false);
            this.abh = null;
            this.aan = 1;
            this.aaj = 1;
            this.ab = ScatterPolygonSeries.$;
        }
        bk() {
            return new ScatterPolygonSeries();
        }
        get_fr() {
            return true;
        }
        get_fm() {
            return true;
        }
        yp() {
            return this.aax();
        }
        zx(a) {
            let b = a;
            b.db(this.ab3);
            b.dc(this.aaw);
            super.zx(a);
            if (this.d7(a)) {
                return;
            }
            let c, d;
            let e = a.getViewInfo(c, d);
            c = e.p0;
            d = e.p1;
            let f = this.getEffectiveViewport1(a);
            this.aas = new ScalerParams(1, d, c, this.xo.df);
            this.aas.c = f;
            this.aat = new ScalerParams(1, d, c, this.xq.df);
            this.aat.c = f;
            if (c.width < 1 || c.height < 1) {
                return;
            }
            this.aav = ((() => {
                let $ret = new ShapeAxisInfoCache();
                $ret.a = this.xo;
                $ret.b = this.xq;
                $ret.e = this.xo.df;
                $ret.f = this.xq.df;
                $ret.d = this.dp;
                $ret.c = this.x6;
                return $ret;
            })());
            if (this.aax()) {
                let g = new Dictionary$2(Base.$, OwnedPoint.$, 0);
                b.du.l(g, 400, d, c, this.ie);
                b.du.j(g, false);
                if (this.yn()) {
                    this.abe(a);
                }
            }
        }
        abe(a) {
            a.dy = true;
            this.xv.ay(this, this.yn(), runOn(this, this.xe));
            let b = this.xv.d;
            let c = b != null;
            let d = this.getEffectiveViewport1(a);
            let e = this.dp == null ? 0 : this.dp.count;
            a.d9((f) => {
                if (f._visibility == 0) {
                    let g = f.ak;
                    let h = f.content;
                    if (h == null) {
                        h = new DataContext();
                        f.content = h;
                    }
                    if (c) {
                        this.zs(g, e, a.t);
                    }
                    this.xv.ac(f, h);
                }
            });
        }
        aax() {
            return this.abh != null && ((this.aar != 1 && this.aar != 0) || this.abi != null);
        }
        ct() {
            return new ScatterPolygonSeriesView(this);
        }
        q7(a) {
            super.q7(a);
            this.aau = a;
        }
        get_hasMarkers() {
            return true;
        }
        get_en() {
            return this.aar != 13 && this.aar != 1;
        }
        vv() {
            return this.abx;
        }
        vw() {
            return this.aby;
        }
        s7() {
            return this.abg;
        }
        mf() {
            return this.mg(this, this.abh);
        }
        ip() {
            return this.aaz;
        }
        get aao() {
            return this.aan;
        }
        set aao(a) {
            this.aan = a;
        }
        aaq() {
            if (this.aap == 0) {
                return 1;
            }
            return this.aap;
        }
        st(a) {
            super.st(a);
            this.aap = a;
        }
        get aak() {
            return this.aaj;
        }
        set aak(a) {
            this.aaj = a;
        }
        aam() {
            if (this.aal == 0) {
                return 2;
            }
            return this.aal;
        }
        ss(a) {
            super.ss(a);
            this.aal = a;
        }
        su(a) {
            super.su(a);
            this.aaz = a;
        }
        sp() {
            super.sp();
            if (this.index < 0) {
                return;
            }
            if (this.abi != null) {
                this.aau.d8();
                this.aau.d5();
            }
            else {
                let a = MarkerSeries.xl(this, this.aar);
                let b = MarkerSeries.xy(a);
                if (b == null) {
                    this.abg = MarkerSeries.yd;
                }
                else {
                    this.aau.d2(b);
                }
            }
            if (this.abz != null && this.aar != 13) {
                this.sg("ActualMarkerBrush");
                let c = this.abx;
                this.aau.d6();
                this.aau.d3();
                let d = this.abx;
                let e = this.fi("ActualMarkerBrush", this.hw.f > 0 ? this.hw.d() : null, c, d);
                this.si("ActualMarkerBrush", e);
            }
            else {
                if (this.aar == 13) {
                    this.abx = this.cw.b5();
                }
                else {
                    if (this.aak != 2) {
                        if (this.dc != null) {
                            let f = this.dc.ww(this.index);
                            if (!isNaN_(this.id) && this.id != 1) {
                                f = BrushUtil.s(f, this.id);
                            }
                            this.abx = f;
                        }
                        else {
                            this.abx = null;
                        }
                    }
                }
            }
            if (this.ab0 != null) {
                this.aau.d7();
                this.aau.d4();
            }
            else {
                if (this.aar == 13) {
                    this.aby = this.cw.b5();
                }
                else {
                    if (this.aap == 2) {
                        this.aby = this.abx;
                    }
                    else {
                        this.aby = this.dc == null ? null : this.dc.wx(this.index);
                    }
                }
            }
            if (this.aak == 2 && this.abz == null && this.aar != 13) {
                if (this.aby != null) {
                    let g = this.aby;
                    if (!isNaN_(this.id) && this.id != 1) {
                        g = BrushUtil.s(g, this.id);
                    }
                    this.abx = g;
                }
                else {
                    this.abx = null;
                }
            }
        }
        qy() {
            super.qy();
            this.aao = this.aaq();
            this.aak = this.aam();
        }
        rg(a, b, c, d) {
            super.rg(a, b, c, d);
            switch (b) {
                case ScatterPolygonSeries.$$p[3]:
                case ScatterPolygonSeries.$$p[11]:
                case ScatterPolygonSeries.$$p[7]:
                case ScatterPolygonSeries.$$p[9]:
                case ScatterPolygonSeries.$$p[10]:
                    this.rm(b);
                    this.q9();
                    break;
                case ScatterPolygonSeries.$$p[6]:
                    this.aao = this.aaq();
                    this.rm(null);
                    this.q9();
                    break;
                case ScatterPolygonSeries.$$p[5]:
                    this.aak = this.aam();
                    this.rm(null);
                    this.q9();
                    break;
                case ScatterPolygonSeries.$$p[2]:
                    this.abh = d;
                    if (c == MarkerSeries.yd || d == MarkerSeries.yd || (c == null || d != null)) {
                        this.aau.ea();
                        this.ry(false);
                    }
                    this.cw.bx();
                    if (this.toolTip != null && this.fj) {
                        this.ba.a$as(this, this.toolTip);
                    }
                    this.ry(false);
                    this.qr();
                    break;
                case ScatterPolygonSeries.$$p[12]:
                    this.aau.db(this.ab3);
                    this.ry(false);
                    this.qr();
                    break;
                case ScatterPolygonSeries.$$p[13]:
                    this.aau.dc(this.aaw);
                    this.ry(false);
                    this.qr();
                    break;
                case ScatterPolygonSeries.$$p[4]:
                    this.ry(false);
                    this.qr();
                    break;
                case ScatterPolygonSeries.$$p[0]:
                case ScatterPolygonSeries.$$p[1]:
                    if (this.aax()) {
                        this.ry(false);
                    }
                    break;
            }
        }
        a2(a, b) {
            let c = this.aau.ch(a);
            let d = null;
            if (c != null) {
                d = c.content;
            }
            if (d != null) {
                return d;
            }
            return super.a2(a, b);
        }
        abf(a, b) {
            let c = new List$1(Base.$, 0);
            for (let d of fromEnum(b.c)) {
                if (!a.containsKey(d)) {
                    c.add1(d);
                }
            }
            for (let e of fromEnum(c)) {
                b.h(e);
            }
        }
        ed(a, b, c, d, e) {
            if (!this.hasMarkers) {
                return false;
            }
            let f = this.xo;
            let g = new ScalerParams(1, this.dc.xm, this.w2, f.df);
            g.c = this.getEffectiveViewport1(this.cw);
            let h = this.xq;
            let i = new ScalerParams(1, this.dc.xm, this.w2, h.df);
            i.c = this.getEffectiveViewport1(this.cw);
            a.clear();
            this.aau.d9((j) => {
                if (j._visibility == 0) {
                    let k = new SeriesPointOfInterest();
                    let l = j.n;
                    let m = j.o;
                    if (!e && (l < this.w2.left || l > this.w2.right || m < this.w2.top || m > this.w2.bottom)) {
                        return;
                    }
                    k.d = f.fw(l, g);
                    k.e = h.fw(m, i);
                    k.b = j.content;
                    k.g = this.vq;
                    k.c = j.ak;
                    if (this.ha) {
                        k.g = this.vx(j.ak);
                    }
                    a.add(k);
                }
            });
            return true;
        }
        aah(a, b, c, d, e) {
            if (c == null || c.length != this.aav.d.count) {
                c = new Array(this.aav.d.count);
                for (let f = 0; f < this.aav.d.count; f++) {
                    c[f] = PointUtil.create();
                }
            }
            let g = ((() => {
                let $ret = new ScalerParams(1, d, e, this.xo.df);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let h = ((() => {
                let $ret = new ScalerParams(1, d, e, this.xq.df);
                $ret.c = this.getEffectiveViewport1(a);
                return $ret;
            })());
            let i = this.wt(a);
            let j = this.aav.a.fw(i.left, g);
            let k = this.aav.a.fw(i.right, g);
            let l = this.aav.b.fw(i.bottom, h);
            let m = this.aav.b.fw(i.top, h);
            if (this.aav.e) {
                let n = j;
                j = k;
                k = n;
            }
            if (this.aav.f) {
                let o = l;
                l = m;
                m = o;
            }
            let p = this.aav;
            let q = p.a;
            let r = p.b;
            let s;
            let t;
            let u = g.d.left;
            let v = g.d.right;
            let w = h.d.top;
            let x = h.d.bottom;
            for (let y = 0; y < this.aav.d.count; y++) {
                s = 0;
                t = 0;
                let z = null;
                let aa = a.cp.tryGetValue(y, z);
                z = aa.p1;
                if (z == null) {
                    c[y].x = NaN;
                    c[y].y = NaN;
                }
                else {
                    let ab = z.c;
                    let ac = RectUtil.l(ab);
                    s = ac.x;
                    t = ac.y;
                    if (s >= u && s <= v && t >= w && t <= x) {
                        c[y].x = s;
                        c[y].y = t;
                    }
                    else {
                        c[y].x = NaN;
                        c[y].y = NaN;
                    }
                }
            }
            return c;
        }
        aay(a, b) {
            if (b == null) {
                b = new List$1(Number_$type, 2, a.e);
            }
            else {
                b.clear();
            }
            let c = 0;
            let d = this.dp;
            for (let e of fromEnum(a.c)) {
                b.add(d.indexOf(e));
                c++;
            }
            return b;
        }
        ak(a, b) {
            let c = new List$1(ChartSelection.$, 0);
            this.qa(a, c, b);
            return c.toArray();
        }
        qa(a, b, c) {
            this.zp(a, b, c);
        }
    }
    ScatterPolygonSeries.$t = markType(ScatterPolygonSeries, 'ScatterPolygonSeries', ShapeSeriesBase.$);
    ScatterPolygonSeries.ab1 = new Rect(0, 0, 0, 1, 1);
    ScatterPolygonSeries.$$p = markDep(DependencyProperty, PropertyMetadata, ScatterPolygonSeries, 'raisePropertyChanged', ['ActualMarkerBrush:abx:abj', [Brush.$], 'ActualMarkerOutline:aby:abk', [Brush.$], 'ActualMarkerTemplate:abg:abl', [DataTemplate.$, null], 'MarkerBrush:abz:abm', [Brush.$], 'MarkerCollisionAvoidance:aai:abn', [CollisionAvoidanceType_$type, enumGetBox(CollisionAvoidanceType_$type, 0)], 'MarkerFillMode:aal:abo', [MarkerFillMode_$type, enumGetBox(MarkerFillMode_$type, 0)], 'MarkerOutlineMode:aap:abp', [MarkerOutlineMode_$type, enumGetBox(MarkerOutlineMode_$type, 0)], 'MarkerOutline:ab0:abq', [Brush.$], 'MarkerStyle:ab2:abr', [Style.$], 'MarkerTemplate:abi:abs', [DataTemplate.$, null], 'MarkerThickness:aaz:abt', [1, DeviceUtils.g(2)], 'MarkerType:aar:abu', [MarkerType_$type, enumGetBox(MarkerType_$type, 1)], 'ShapeStyle:ab3:abv', [Style.$, null], 'ShapeStyleSelector:aaw:abw', [StyleSelector.$, null]]);
    return ScatterPolygonSeries;
})();
/**
 * @hidden
 */
export let ScatterPolygonSeriesView = /*@__PURE__*/ (() => {
    class ScatterPolygonSeriesView extends ShapeSeriesViewBase {
        constructor(a) {
            super(a);
            this.dy = false;
            this.dp = null;
            this.d0 = null;
            this.dv = null;
            this.dt = null;
            this.dx = false;
            this.dw = null;
            this.d1 = null;
            this.dq = new Marker();
            this.eh = null;
            this.dq = new Marker();
            this.dq.content = new DataContext();
            this.dv = a;
            this.dw = new HashPool$2(Base.$, Marker.$);
            this.d1 = new List$1(Marker.$, 0);
            this.eb(this.dw);
            this.dt = new NumericMarkerManager(1, (b) => this.dw.item(b), (b) => this.dv.aav.d.item(b), runOn(this, this.ef), runOn(this, this.dn), runOn(this, this.dz), () => this.dv.aai);
            this.dt.q = runOn(this, this.ei);
        }
        a4() {
            super.a4();
            if (!this.t) {
                this.dv.ab0 = Defaults.bb;
                this.dv.jt = Defaults.am;
                this.dv.aaz = Defaults.al;
                this.dv.aar = Defaults.f;
                this.dv.aal = Defaults.b;
            }
        }
        get du() {
            return this.dt;
        }
        ef(a) {
            this.dv.abf(a, this.dw);
        }
        dn() {
            this.dp = this.dv.aah(this, this.dw, this.dp, this.ca, this.b9);
            return this.dp;
        }
        dz() {
            this.d0 = this.dv.aay(this.dw, this.d0);
            return this.d0;
        }
        di(a, b) {
            return this.dj(a, b, true);
        }
        cz(a, b, c) {
            super.cz(a, b, c);
            ShapeSeriesViewBase.cy(this, a, b);
        }
        cx(a, b) {
            let c = a;
            if (c == null) {
                return;
            }
            c.an = b;
        }
        d9(a) {
            this.dw.f(a);
        }
        eb(a) {
            a.create = runOn(this, this.ds);
            a.destroy = runOn(this, this.ed);
            a.activate = runOn(this, this.ec);
            a.disactivate = runOn(this, this.ee);
        }
        ds() {
            let a = new Marker();
            if (!this.dx) {
                a.content = ((() => {
                    let $ret = new DataContext();
                    $ret.series = this.f;
                    return $ret;
                })());
            }
            a.ah = this.f.abg;
            this.d1.add(a);
            return a;
        }
        ch(a) {
            let b = this.dr(a, 0);
            if (b == null) {
                b = this.dr(a, 3);
            }
            return b;
        }
        dr(a, b) {
            let c;
            let d;
            let e;
            let f;
            for (let g = this.d1.count - 1; g >= 0; g--) {
                let h = this.d1._inner[g];
                if (h._visibility == 1 || h._opacity == 0) {
                    continue;
                }
                c = (h.m / 2) + b;
                d = (h.l / 2) + b;
                e = h.ai;
                f = h.aj;
                if ((h.n + e) - c <= a.x && (h.n + e) + c >= a.x && (h.o + f) - d <= a.y && (h.o + f) + d >= a.y) {
                    return h;
                }
            }
            return null;
        }
        ed(a) {
            a.content = null;
            this.d1.remove(a);
        }
        ec(a) {
            a._visibility = 0;
        }
        ee(a) {
            if (a.content != null) {
                (typeCast(DataContext.$, a.content)).item = null;
            }
            a._visibility = 1;
        }
        eg(a) {
            this.dx = a;
        }
        bv(a, b) {
            super.bv(a, b);
            if (!this.dy) {
                let c = a;
                let d = c.content;
                if (d != null) {
                    if (this.dv.abx != null) {
                        d.actualItemBrush = this.dv.abx;
                    }
                    else {
                        d.actualItemBrush = this.cj.vj;
                    }
                    if (this.dv.abx != null) {
                        d.outline = this.dv.aby;
                    }
                    else {
                        d.outline = this.cj.vn;
                    }
                    d.thickness = this.dv.aaz;
                }
            }
        }
        bw(a, b) {
            super.bw(a, b);
            let c = a;
            this.dq._visibility = c._visibility;
            this.dq.ah = c.ah;
            this.dq.width = c.width;
            this.dq.height = c.height;
            this.dq.m = c.m;
            this.dq.l = c.l;
            this.dq.n = c.n;
            this.dq.o = c.o;
            let d = this.b4(b);
            let e = this.dq.content;
            let f = c.content;
            e.item = f.item;
            e.series = f.series;
            e.thickness = f.thickness;
            if (e != null) {
                e.actualItemBrush = d;
                e.outline = d;
                e.thickness = this.dv.aaz + 3;
            }
        }
        bi(a, b) {
            super.bi(a, b);
            let c = new DataTemplatePassInfo();
            c.isHitTestRender = b;
            c.context = a.h();
            c.viewportTop = this.b9.top;
            c.viewportLeft = this.b9.left;
            c.viewportWidth = this.b9.width;
            c.viewportHeight = this.b9.height;
            c.passID = "Markers";
            let d = new DataTemplateRenderInfo();
            d.passInfo = c;
            d.isHitTestRender = b;
            let e = new DataTemplateMeasureInfo();
            e.passInfo = c;
            let f = false;
            let g = a.h();
            e.context = g;
            d.context = g;
            let h = 0;
            let i = 0;
            if (this.dv.abg != null && this.dv.abg.passStarting != null) {
                this.dv.abg.passStarting(c);
            }
            for (let j = 0; j < this.d1.count; j++) {
                let k = this.d1._inner[j];
                if (k._visibility == 1) {
                    continue;
                }
                this.bu(k, j, b);
                if (b) {
                    k = this.dq;
                }
                if (!f) {
                    e.width = k.width;
                    e.height = k.height;
                    e.renderOffsetX = 0;
                    e.renderOffsetY = 0;
                    e.renderContext = a;
                    let l = k.ah;
                    if (l.measure != null) {
                        e.data = k.content;
                        l.measure(e);
                        f = e.isConstant;
                        if (f) {
                            h = e.width;
                            i = e.height;
                        }
                    }
                    d.availableWidth = e.width;
                    d.availableHeight = e.height;
                    d.renderOffsetX = e.renderOffsetX;
                    d.renderOffsetY = e.renderOffsetY;
                    d.renderContext = a;
                }
                else {
                    d.availableWidth = h;
                    d.availableHeight = i;
                }
                if (!isNaN_(k.width) && !isInfinity(k.width)) {
                    d.availableWidth = k.width;
                }
                if (!isNaN_(k.height) && !isInfinity(k.height)) {
                    d.availableHeight = k.height;
                }
                a.q(d, k);
                k.m = d.availableWidth;
                k.l = d.availableHeight;
                k.ai = d.renderOffsetX;
                k.aj = d.renderOffsetY;
            }
            if (this.dv.abg != null && this.dv.abg.passCompleted != null) {
                this.dv.abg.passCompleted(c);
            }
        }
        d8() {
            this.dv.abg = null;
        }
        d5() {
            this.dv.abg = null;
            this.dv.abg = this.dv.abi;
        }
        d6() {
            this.dv.abx = null;
        }
        d3() {
            this.dv.abx = null;
            if (!isNaN_(this.f.id) && this.f.id != 1) {
                let a = BrushUtil.s(this.dv.abz, this.f.id);
                this.dv.abx = a;
            }
            else {
                this.dv.abx = this.dv.abz;
            }
        }
        d7() {
            this.dv.aby = null;
        }
        d4() {
            this.dv.aby = null;
            this.dv.aby = this.dv.ab0;
        }
        d2(a) {
            switch (a) {
                case "CircleMarkerTemplate":
                    this.dv.abg = this.dv.dc.td;
                    break;
                case "TriangleMarkerTemplate":
                    this.dv.abg = this.dv.dc.tm;
                    break;
                case "PyramidMarkerTemplate":
                    this.dv.abg = this.dv.dc.tj;
                    break;
                case "SquareMarkerTemplate":
                    this.dv.abg = this.dv.dc.tk;
                    break;
                case "DiamondMarkerTemplate":
                    this.dv.abg = this.dv.dc.te;
                    break;
                case "PentagonMarkerTemplate":
                    this.dv.abg = this.dv.dc.th;
                    break;
                case "HexagonMarkerTemplate":
                    this.dv.abg = this.dv.dc.tf;
                    break;
                case "TetragramMarkerTemplate":
                    this.dv.abg = this.dv.dc.th;
                    break;
                case "PentagramMarkerTemplate":
                    this.dv.abg = this.dv.dc.ti;
                    break;
                case "HexagramMarkerTemplate":
                    this.dv.abg = this.dv.dc.tg;
                    break;
            }
        }
        ea() {
            for (let a of fromEnum(this.d1)) {
                a.ah = this.dv.abg;
            }
            this.a2();
        }
        ei(a) {
            if (this.eh == null) {
                this.eh = new DataTemplateMeasureInfo();
                this.eh.context = this.m.h();
            }
            this.eh.width = a.width;
            this.eh.height = a.height;
            this.eh.data = a.content;
            let b = a.ah;
            if (b.measure != null) {
                b.measure(this.eh);
            }
            return new Size(1, this.eh.width, this.eh.height);
        }
        ax(a) {
            let b = a;
            super.ax(b);
            for (let c of fromEnum(this.dw.c)) {
                let d = this.dw.item(c);
                if (d._visibility != 1) {
                    let e = typeCast(ScatterPolygonSeries.$, this.f);
                    let f = this.f.bc.getMarkerVisualData(e, d, e.abg);
                    b.markerShapes.add(typeCast(MarkerVisualData.$, f));
                }
            }
        }
        getDefaultTooltipTemplate() {
            let a = "<div class='ui-chart-default-tooltip-content'><span";
            let b = this.f.ba.a$u(this.f);
            if (!stringIsNullOrEmpty(b)) {
                a += " style='color:" + b + "'";
            }
            a += ">" + this.dv.title + "</span><br/>";
            a += "</div>";
            return a;
        }
    }
    ScatterPolygonSeriesView.$t = markType(ScatterPolygonSeriesView, 'ScatterPolygonSeriesView', ShapeSeriesViewBase.$);
    return ScatterPolygonSeriesView;
})();
